
buildsna

bank 0

org 0
ld a,h : add 8 : ld h,a : and #38 : ret nz
ld a,h : sub #40 : ld h,a : ld a,l : add 80 : ld l,a : ret nc
inc h
ret

org #36
defw 0
org #38
ei : ret

run #100
org #100
;----------------------------------------------
                  InitMenu
;----------------------------------------------
ld sp,#100
ld bc,#7F80+%1100 : out (c),c
ld bc,#BC00+12 : out (c),c : inc b : ld a,#30 : out (c),a
ld bc,#BC00+13 : out (c),c : inc b : out (c),0
ld hl,palette_black : call setPalette
call MotorON
ld bc,#7FC4 : call SetRAM : ld iy,TrackLoad_LoadingCredits  : call ReadSequence ; credits en bank 4
call MotorOFF
ld hl,0 : ld (#36),a

; display menu

xor a : ld hl,muzak : call PLY_AKG_INIT
di : ld a,#C3 : ld hl,MusicHandler
ld (#38),a : ld (#39),hl
ei
;----------------------------------------------
                  GameMenu
;----------------------------------------------
YCENTER=4
ld hl,palette_black : call setPalette
ld hl,#C000:ld de,#C001:ld (hl),l:ld bc,16383:ldir
ld hl,fontBlack : ld (currentFont),hl : ld de,#C007+80*(0+YCENTER) : ld hl,str_titre : call displayString

ld hl,fontGreen : ld (currentFont),hl : ld de,#C018+80*(3+YCENTER) : ld hl,str_start : call displayString
ld hl,fontRed   : ld (currentFont),hl : ld de,#C018+80*(5+YCENTER) : ld hl,str_mode  : call displayString
ld hl,fontBlue  : ld (currentFont),hl : ld de,#C018+80*(7+YCENTER) : ld hl,str_olymp : call displayString
ld hl,fontBlack : ld (currentFont),hl : ld de,#C018+80*(9+YCENTER) : ld hl,str_creds : call displayString

ld hl,fontGreen : ld (currentFont),hl : ld de,#C009+80*(12+YCENTER): ld hl,str_copy  : call displayString

ld hl,palette_ingame : call setPalette
call scanKeyboardrelease
.rescan
call fullvbl
.dispDep ld hl,10*1024+#4000
ld de,#C000+32+80*(15+YCENTER)
ld xl,26
.dispLine push de : ld bc,16 : ldir : pop de : ex hl,de : rst 0 : ex hl,de : dec xl : jr nz,.dispLine

.dispWait ld a,5 : dec a : ld (.dispWait+1),a : jr nz,.next
ld a,5 : ld (.dispWait+1),a
.dispeu ld hl,peupon_list : ld e,(hl) : inc hl : ld d,(hl) : inc hl : ld (.dispeu+1),hl : ld (.dispDep+1),de
ld a,e : or d : jr nz,.next
ld hl,10*1024+#4000+26*16*0 : ld (.dispDep+1),hl : ld hl,peupon_list : ld (.dispeu+1),hl
.next


call scanKeyboard
xor a : ld (#36),a
ld a,(KEY_0_BYTE)  : and KEY_0_BIT  : jp nz,MenuHelp
ld a,(KEY_F0_BYTE) : and KEY_F0_BIT : jp nz,MenuHelp
ld a,(KEY_1_BYTE)  : and KEY_1_BIT  : jp nz,MenusingleRace
ld a,(KEY_F1_BYTE) : and KEY_F1_BIT : jp nz,MenusingleRace
ld a,(KEY_2_BYTE)  : and KEY_2_BIT  : jp nz,Olympics
ld a,(KEY_F2_BYTE) : and KEY_F2_BIT : jp nz,Olympics
ld a,(KEY_3_BYTE)  : and KEY_3_BIT  : jp nz,displayCredits
ld a,(KEY_F3_BYTE) : and KEY_F3_BIT : jp nz,displayCredits

ld a,(KEY_B_BYTE) : cp KEY_B_BIT|KEY_T_BIT|KEY_R_BIT : jp nz,.rescan
ld a,(KEY_E_BYTE) : AND KEY_E_BIT : cp KEY_E_BIT : jp nz,.rescan
ld a,(KEY_U_BYTE) : AND KEY_U_BIT : cp KEY_U_BIT : jp nz,.rescan
.displayCheat
ld hl,fontRed : ld (currentFont),hl : ld de,#E013+80*(10+YCENTER) : ld hl,str_cheat  : call displayString
ld a,1 : ld (#37),a
jp .rescan

peupon_list
defw 10*1024+#4000+26*16*1
defw 10*1024+#4000+26*16*2
defw 10*1024+#4000+26*16*3
defw 10*1024+#4000+26*16*4
defw 10*1024+#4000+26*16*5
defw 10*1024+#4000+26*16*6
defw 10*1024+#4000+26*16*7
defw 10*1024+#4000+26*16*6
defw 10*1024+#4000+26*16*5
defw 10*1024+#4000+26*16*4
defw 10*1024+#4000+26*16*3
defw 10*1024+#4000+26*16*2
defw 10*1024+#4000+26*16*1
defw 0

;----------------------------------------------
                    Olympics
;----------------------------------------------
.init ld hl,.races : ld (.next+1),hl
ld a,1 : ld (#36),a ; olympics :)

di : call PLY_AKG_STOP : ld hl,#C9FB : ld (#38),hl : ei

.next ld hl,.races
ld e,(hl) : inc hl : ld d,(hl) : inc hl : ld a,e : or d : jp z,.champion
push hl,de
call .clearScreen
ld hl,fontGreen : ld (currentFont),hl : ld de,#C008+80*(7+YCENTER) : pop hl : call displayString
ld bc,0 : .mint ld a,5 : dec a : jr nz,$-1 : djnz .mint : dec c : jr nz,.mint
pop hl
ld e,(hl) : inc hl : ld d,(hl) : inc hl : ld (.next+1),hl : ex hl,de : jp (hl)

.return
call MotorON : ld bc,#7FC0 : call SetRAM : ld iy,TrackLoadWinnerLoser  : call ReadSequence
ld bc,#7FC4 : call SetRAM : ld iy,TrackLoad_LoadingCredits  : call ReadSequence : call MotorOFF
ld bc,#7FC0 : call SetRAM
ld bc,#BC00+12:out (c),c:inc b :ld a,#30:out (c),a
; win or lose
ld hl,(.next+1)
ld a,(chronom)   : cp (hl) : jp nc,.lose : inc hl
ld (.next+1),hl
; win
ld hl,LeonWinner : ld de,#C000 : call unzx0 : ld hl,palette_credits : call setPalette
ld a,1 : ld hl,muzak : call PLY_AKG_INIT
ld bc,480 : .jingleWin push bc : call fullvbl : call PLY_AKG_PLAY : pop bc : dec bc : ld a,b : or c : jr nz,.jingleWin : call PLY_AKG_STOP
call scanKeyBoardPress
ld bc,#7FC4 : call SetRAM ; on se prepare au loading suivant
jp .next

.lose
ld hl,LeonLoser : ld de,#C000 : call unzx0 : ld hl,palette_credits : call setPalette
ld a,2 : ld hl,muzak : call PLY_AKG_INIT
ld b,180 : .jingleLose push bc : call fullvbl : call PLY_AKG_PLAY : pop bc : djnz .jingleLose : call PLY_AKG_STOP
call scanKeyBoardPress
jp InitMenu


.champion
ld hl,palette_black : call setPalette
call MotorON : ld bc,#7FC0 : call SetRAM : ld iy,TrackLoadChampion  : call ReadSequence : call MotorOFF
ld hl,#4000 : ld de,#C000 : call unzx0 : ld hl,palette_credits : call setPalette
ld hl,endMusic : xor a : call endPlayer
.zikend call fullvbl : call endPlayer+3 : call scankeyboard
ld hl,keyboardmap : xor a : ld b,10
.iskey or (hl) : inc hl : djnz .iskey
or a : jr z,.zikend
call endPlayer+6
call .clearScreen

; doping?
ld a,(#37) : or a : jp z,.noDoping

ld hl,fontBlue  : ld (currentFont),hl : ld de,#C006+80*(3+YCENTER)   : ld hl,str_doping1 : call displayString
ld hl,fontGreen : ld (currentFont),hl : ld de,#C008+80*(5+YCENTER)+6 : ld hl,str_doping2 : call displayString
ld hl,fontRed   : ld (currentFont),hl : ld de,#C008+80*(7+YCENTER)+8 : ld hl,str_doping3 : call displayString
ld hl,fontBlack : ld (currentFont),hl : ld de,#C008+80*(9+YCENTER)+14: ld hl,str_doping4 : call displayString
call .KeyclearScreen
jp InitMenu

.noDoping
; message de fin
ld hl,fontBlue  : ld (currentFont),hl : ld de,#C008+80*(3+YCENTER)  : ld hl,str_champi1 : call displayString
ld hl,fontGreen : ld (currentFont),hl : ld de,#C008+80*(5+YCENTER)  : ld hl,str_champi2 : call displayString
ld hl,fontRed   : ld (currentFont),hl : ld de,#C008+80*(7+YCENTER)  : ld hl,str_champi3 : call displayString
ld hl,fontBlack : ld (currentFont),hl : ld de,#C008+80*(9+YCENTER)  : ld hl,str_champi4 : call displayString
ld hl,fontBlue  : ld (currentFont),hl : ld de,#C008+80*(11+YCENTER) : ld hl,str_champi5 : call displayString
ld hl,fontGreen : ld (currentFont),hl : ld de,#C008+80*(13+YCENTER) : ld hl,str_champi6 : call displayString

ld hl,InitMenu : push hl

.KeyclearScreen
call scanKeyBoardPress
.clearScreen
ld hl,palette_black : call setPalette
ld hl,#C000 : ld de,#C001 : ld (hl),l : ld bc,16383 : ldir
ld hl,palette_ingame : call setPalette
ret

.races
defw str_nage1,Breast200init : defb 2 ; 200m brasse
defw str_nage2,Butter200init : defb 2 ; 200m papillon
defw str_nage3,Medley200init : defb 2 ; 200m 4 nages
defw str_nage4,Medley400init : defb 5 ; 400m 4 nages
defw 0

;----------------------------------------------
                 MenuSingleRace
;----------------------------------------------
YCENTER=4
ld hl,palette_black : call setPalette
ld hl,#C000:ld de,#C001:ld (hl),l:ld bc,16383:ldir
ld hl,fontBlack : ld (currentFont),hl : ld de,#C007+80*(0+YCENTER) : ld hl,str_titre : call displayString
ld hl,fontBlue  : ld (currentFont),hl : ld de,#C018+80*(2+YCENTER) : ld hl,str_single : call displayString
ld hl,fontGreen : ld (currentFont),hl : ld de,#C019+80*(4+YCENTER) : ld hl,str_crawl  : call displayString
ld hl,fontRed   : ld (currentFont),hl : ld de,#C019+80*(6+YCENTER) : ld hl,str_breast : call displayString
ld hl,fontBlue  : ld (currentFont),hl : ld de,#C019+80*(8+YCENTER) : ld hl,str_butter : call displayString
ld hl,fontBlack : ld (currentFont),hl : ld de,#C019+80*(10+YCENTER) : ld hl,str_back   : call displayString
ld hl,fontGreen : ld (currentFont),hl : ld de,#C009+80*(12+YCENTER): ld hl,str_copy  : call displayString

ld hl,palette_ingame : call setPalette
call scanKeyboardrelease
.rescan
call scanKeyboard
ld a,(KEY_0_BYTE)  : and KEY_0_BIT  : jp nz,raceCrawl
ld a,(KEY_F0_BYTE) : and KEY_F0_BIT : jp nz,raceCrawl
ld a,(KEY_1_BYTE)  : and KEY_1_BIT  : jp nz,raceBreast
ld a,(KEY_F1_BYTE) : and KEY_F1_BIT : jp nz,raceBreast
ld a,(KEY_2_BYTE)  : and KEY_2_BIT  : jp nz,raceButter
ld a,(KEY_F2_BYTE) : and KEY_F2_BIT : jp nz,raceButter
ld a,(KEY_3_BYTE)  : and KEY_3_BIT  : jp nz,raceBack
ld a,(KEY_F3_BYTE) : and KEY_F3_BIT : jp nz,raceBack
ld a,(KEY_ESC_BYTE) : or a : jp nz,GameMenu
jp .rescan




;----------------------------------------------
                    MenuHelp
;----------------------------------------------
ld hl,palette_black : call setPalette
ld hl,#C000:ld de,#C001:ld (hl),l:ld bc,16383:ldir

ld hl,fontBlack : ld (currentFont),hl : ld de,#C007+80*(0+YCENTER) : ld hl,str_titre : call displayString

ld hl,fontBlue  : ld (currentFont),hl : ld de,#C015+80*(3+YCENTER) : ld hl,str_help1 : call displayString
ld hl,fontGreen : ld (currentFont),hl : ld de,#C015+80*(5+YCENTER) : ld hl,str_help2 : call displayString
ld hl,fontRed   : ld (currentFont),hl : ld de,#C015+80*(7+YCENTER) : ld hl,str_help3 : call displayString
ld hl,fontBlack : ld (currentFont),hl : ld de,#C015+80*(9+YCENTER)+12 : ld hl,str_help4 : call displayString

ld hl,fontGreen : ld (currentFont),hl : ld de,#C009+80*(12+YCENTER): ld hl,str_copy  : call displayString

ld hl,palette_ingame : call setPalette
call scanKeyboardrelease
.rescan
call scanKeyboard
ld a,(KEY_SPACE_BYTE)  : or a : jp nz,GameMenu
ld a,(KEY_ESC_BYTE) : or a : jp nz,GameMenu
jr .rescan

scanKeyboardrelease
call scanKeyboard
ld hl,keyboardmap : ld b,10
.scan ld a,(hl) : or a : jr nz,scanKeyboardrelease : inc hl : djnz .scan
ret
scanKeyBoardPress
call scanKeyboardrelease
.rescan
call scanKeyboard
ld hl,keyboardmap : ld b,10 : xor a
.scan or (hl) : inc hl : djnz .scan
or a : ret nz
jr .rescan

;----------------------------------------------
displayCredits
ld hl,palette_black : call setPalette
ld hl,#5000 : ld de,#C000 : call unzx0
ld hl,palette_credits : call setPalette
.rescan
call scanKeyboard
ld a,(KEY_SPACE_BYTE) : or a : jp nz,GameMenu
ld a,(KEY_ESC_BYTE) : or a : jp nz,GameMenu
jr .rescan

displayString ld a,(hl) : and #7F : push hl : call displayChar : pop hl : ld a,(hl) : add a : ret c : inc hl : jr displayString
displayChar
push de 
add a : add a : ld l,a : ld h,0 : add hl,hl : add hl,hl : ld bc,(currentFont) : add hl,bc
ld b,7
.dispsp ld a,(hl) : ld (de),a : inc hl : inc de : ld a,(hl) : inc hl : ld (de),a : dec de : ex hl,de : rst 0 : ex hl,de : djnz .dispsp
pop de : inc de : inc de
ret
currentFont defw fontBlack

charset ' !"#$%&\'()*+,-./0123456789:;,=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ',0

str_titre str "LEON MARCHAND'S OLYMPIC CHALLENGE"
str_start str '0. HOW TO PLAY?'
str_mode  str '1. SINGLE RACE'
str_olymp str '2. OLYMPICS MODE'
str_creds str '3. CREDITS'
str_cheat str 'CHEAT MODE ACTIVATED'
str_copy  str '(C) 2024 PRALINE & TEAM GALAXY'

str_single str 'SINGLE RACE 100M'
str_crawl  str '0. FREESTYLE'
str_breast str '1. BREASTSTROKE'
str_butter str '2. BUTTERFLY'
str_back   str '3. BACKSTROKE'

str_help1 str 'WHEN THE BEEP SOUNDS'
str_help2 str 'SHAKE A LOT THAT JOY'
str_help3 str 'OR THE CURSOR ON THE'
str_help4 str 'KEYBOARD'


str_doping1 str "YOU'RE ON YOUR WAY TO DOPING CONTROL"
str_doping2 str    "YOU SMELL BUTTER A MILE AWAY" ; 3
str_doping3 str     "YOU GIVE BACK YOUR MEDALS"   ; 4
str_doping4 str        "SPORT MUST BE CLEAN"      ; 7

str_champi1 str "CONGRATULATIONS! WE HOPE YOU LIKED"
str_champi2 str "THIS GAME. IT WAS ALSO A CHALLENGE"
str_champi3 str "FOR US, AS THE FIRST IDEA WAS BORN"
str_champi4 str "A FEW WEEKS AGO. LESS THAN A MONTH"
str_champi5 str " FOR EARLY GRAPHICS AND LESS THAN"
str_champi6 str "   TWO WEEKS FOR CODE AND MUSIC"

str_nage1   str "FIRST EVENT : BREASTSTROKE 200M"
str_nage2   str "  NEXT EVENT : BUTTERFLY 200M"
str_nage3   str "   NEXT EVENT : MEDLEY 200M"
str_nage4   str "   LAST EVENT : MEDLEY 400M"
charset

;.rescan call scankeyboard : ld a,(KEY_SPACE_BYTE) : and KEY_SPACE_BIT : jr z,.rescan
;ld hl,palette_black : call setPalette
;.rescan2 call scankeyboard : ld a,(KEY_SPACE_BYTE) : and KEY_SPACE_BIT : jr nz,.rescan2
; mettre un loading sur l'écran???

; MEGARACE!!! papillon, dos, brasse, crawl
; 400m 4 nages, 200m papillon, 200m brasse et 200m 4 nages
Medley400init
ld a,10
ld hl,nageplongeon64x32_right_0
ld ix,Medley400
ld iy,#8000+28+13*80
jp LoadingRace

Medley200init
ld a,10
ld hl,nageplongeon64x32_right_0
ld ix,Medley200
ld iy,#8000+28+13*80
jr LoadingRace

Butter200init
ld a,10
ld bc,SequenceButter
ld de,SequenceButterRetour
ld hl,nageplongeon64x32_right_0
ld ix,Race200
ld iy,#8000+28+13*80
jr LoadingRace

Breast200init
ld a,10
ld bc,SequenceBreast
ld de,SequenceBreastRetour
ld hl,nageplongeon64x32_right_0
ld ix,Race200
ld iy,#8000+28+13*80
jr LoadingRace

raceCrawl
ld a,10
ld bc,SequenceCrawl
ld de,SequenceCrawlRetour
ld hl,nageplongeon64x32_right_0
ld ix,singleRace
ld iy,#8000+28+13*80
jr LoadingRace

raceBreast
ld a,10
ld bc,SequenceBreast
ld de,SequenceBreastRetour
ld hl,nageplongeon64x32_right_0
ld ix,singleRace
ld iy,#8000+28+13*80
jr LoadingRace

raceButter
ld a,10
ld bc,SequenceButter
ld de,SequenceButterRetour
ld hl,nageplongeon64x32_right_0
ld ix,singleRace
ld iy,#8000+28+13*80
jr LoadingRace

raceBack
ld a,14
ld hl,NagePlongeonDosSheet_Right_0
ld ix,singleRaceBack
ld iy,#9800+28+16*80

LoadingRace
ld (posx),a ; mais 14 pour le dos backstroke!
ld (Race200.move1+1),bc
ld (Race200.mover1+1),de
ld (Race200.move2+1),bc
ld (Race200.mover2+1),de

ld (SingleRace.single+1),bc
ld (SingleRace.singleRetour+1),de
ld (.plongeonStart+1),hl
ld (.ptrRace+1),ix
ld (spritePosition),iy

di : call PLY_AKG_STOP : ld hl,#C9FB : ld (#38),hl : ei

ld hl,palette_black : call setPalette
ld hl,#4000 : ld de,#C000 : call unzx0
ld hl,palette_ingame : call setPalette

BACKT = #7FC7

call MotorON
ld bc,#7FC0 : call SetRAM : ld iy,TrackLoad_Water      : call ReadSequence
ld bc,BACKT : call SetRAM : ld iy,TrackLoad_BackGround : call ReadSequence ; plongeon dos+classique sur la bank 4
ld bc,#7FC4 : call SetRAM : ld iy,TrackLoadSPR_B4      : call ReadSequence
ld bc,#7FC5 : call SetRAM : ld iy,TrackLoadSPR_B5      : call ReadSequence
ld bc,#7FC6 : call SetRAM : ld iy,TrackLoadSPR_B6      : call ReadSequence

ld hl,TimerData : ld b,TimerEndData-TimerData+1 : .razTimer ld (hl),0 : inc hl : djnz .razTimer

;*******************************************
;                StartingTheRace
;*******************************************

ld hl,palette_black : call setPalette
ld bc,BACKT : call SetRAM
ld hl,background : ld de,#C000 : call unzx0

call displayWaves : 

ld a,(posx) : cp 14 : jr nz,.okNoBack
ld b,17 : ld c,#3C
ld hl,#3C3C:ld (#CDBA-#800),hl : ld (#CDB8-#800),hl ; patch
ld hl,#CDB8
.moarWater
ld (hl),c : inc l : ld (hl),c : inc l : ld (hl),c : inc l : ld (hl),c : inc l : ld (hl),c : rst 0
ld (hl),c : dec l : ld (hl),c : dec l : ld (hl),c : dec l : ld (hl),c : dec l : ld (hl),c : rst 0
djnz .moarWater

.okNoBack
ld hl,#86FC : ld (hl),#3E : set 6,h : ld (hl),#3C ; patch
ld hl,(spritePosition) : ld bc,{page}nageplongeon64x32_right_0 : call setRam : .plongeonStart call nageplongeon64x32_right_0 : call flipScreen
ld hl,#C000 : ld de,#8000
ld a,(flipScreen.addr+1) : cp #30 : jr z,.noSwap : ex hl,de : .noSwap
ld bc,16384 : ldir
ld hl,palette_ingame : call setPalette


ld e,50 : .ftempo call fullvbl : dec e : jr nz,.ftempo

ld bc,BACKT : call SetRAM
ld hl,takeMarks : ld de,takeTmp : push de : call unzx0 : pop hl : call display_band

ld e,25 : .tempo call fullvbl : dec e : jr nz,.tempo
ld ix,TakeSample : ld de,takeTmp : call do_sample
ld hl,takeremove : ld de,takeTmp : push de : call unzx0 : pop hl : call display_band
; charger ici la bank de sprites manquants
ld bc,BACKT : ld iy,TrackLoadSPR_B7      : call ReadSequence
call MotorOFF

ld e,10 : .tempo2 call fullvbl : dec e : jr nz,.tempo2 ; on réduit le délai vu qu'il faut charger les sprites!

ld hl,timerHandler : ld a,#C3 : di : ld (#38),a : ld (#39),hl : ei ; install Timer

ld ix,beep : ld de,beep_end : call do_sample

ld hl,#090C : call SendPSG
ld hl,#0700+%101101 : call SendPSG
ld hl,#0614 : call SendPSG

call displayRight
.ptrRace jp SingleRace

MusicHandler
push af
.myint ld a,6 : dec a : ld (.myint+1),a : jr nz,.noInt
ld a,6 : ld (.myint+1),a
push bc,de,hl,ix,iy : exa : exx : push af,bc,de,hl
call PLY_AKG_PLAY
pop hl,de,bc,af : exa : exx : pop iy,ix,hl,de,bc
.noInt
pop af
ei : ret

display_band
ld de,#C000+80+5*#800 : ld xl,23
.displayTakeLine push de : ld bc,80 : ldir : pop de : ex hl,de : rst 0 : ex hl,de : dec xl : jr nz,.displayTakeLine : ret

do_sample
ld hl,#0100 : call SendPSG
ld hl,#0200 : call SendPSG
ld a,e : ld (.cmpL+1),a
ld a,d : ld (.cmpH+1),a
ld h,#09 ; volume B
.sample_reloop
ld a,(ix+0) : rrca : rrca : rrca : rrca : and 15 : ld l,a
call SendPSG
ld b,19 : djnz $
ld a,(ix+0) : and 15 : ld l,a
call SendPSG
ld b,18 : djnz $
inc ix
ld a,xl : .cmpL cp lo(0) : jr nz,.sample_reloop
ld a,xh : .cmpH cp hi(0) : jr nz,.sample_reloop
ld l,0 ; volume OFF then return
jp SendPSG




SingleRace
ld e,70 : call InitSequence ; limiter=70
ld hl,SequencePlongeon : call DoSequence
ld hl,(spritePosition) : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for ondulation
ld hl,SequenceOndulation : call DoSequence
ld hl,(spritePosition) : ld de,-80 : add hl,de : rst 0 : rst 0 : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for crawl
ld a,#E9 : ld (DoSequence.limiter+1),a
.single ld hl,SequenceCrawl : call DoSequence

xor a : ld (DoSequence.sens+1),a ; retournement figé
ld (DoSequence.limiter+1),a ; retour au début
ld hl,SequenceRetournementRight : call DoSequence

call displayLeft
ld hl,SequenceOndulationRetour : call DoSequence
ld a,14 : ld (DoSequence.limiter+1),a
.singleRetour ld hl,SequenceCrawlRetour : call DoSequence
ld hl,#C9FB : ld (#38),hl ; stop TIMER
jp Ending


SingleRaceBack
ld e,70 : call InitSequence ; limiter=70
ld hl,SequencePlongeonDos : call DoSequence
;ld hl,(spritePosition) : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for ondulation
ld hl,SequenceOndulationDos : call DoSequence
ld hl,(spritePosition) : ld de,-80 : add hl,de : rst 0 : rst 0 : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for crawl
ld a,#E9 : ld (DoSequence.limiter+1),a
ld hl,SequenceDos : call DoSequence

xor a : ld (DoSequence.sens+1),a ; retournement figé
ld (DoSequence.limiter+1),a ; retour au début
ld hl,SequenceRetournementRight : call DoSequence

call displayLeft

ld hl,SequenceOndulationDosRetour : call DoSequence
ld a,14 : ld (DoSequence.limiter+1),a
ld hl,SequenceDosRetour : call DoSequence
ld hl,#C9FB : ld (#38),hl ; stop TIMER
jp Ending

displayRight
ld a,#F0 : ld (displayWaves.rc1+1),a : ld (displayWaves.rc2+1),a
xor a : ld (displayWaves.rc3+1),a
ret

displayLeft
ld a,-1 : ld (DoSequence.sens+1),a
ld a,#E9-70 : ld (DoSequence.limiter+1),a
ld a,#3C : ld (displayWaves.rc1+1),a : ld (displayWaves.rc2+1),a
ld a,-2 : ld (displayWaves.rc3+1),a
ret

greyLineLeft
ld hl,#FD67
ld b,17 : ld c,#F0
.razGrey
ld (hl),c : res 6,h : ld (hl),c : rst 0
ld (hl),c : set 6,h : ld (hl),c : rst 0
djnz .razGrey
ret

Race200
ld e,70 : call InitSequence ; limiter=70
ld hl,SequencePlongeon : call DoSequence
ld hl,(spritePosition) : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for ondulation

ld hl,SequenceOndulation : call DoSequence
;ld hl,(spritePosition) : ld de,-80 : add hl,de : rst 0 : rst 0 : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for crawl
ld a,#E9 : ld (DoSequence.limiter+1),a
.move1 ld hl,SequenceButter : call DoSequence

xor a : ld (DoSequence.sens+1),a ; retournement figé
ld (DoSequence.limiter+1),a ; retour au début
ld hl,SequenceRetournementRight : call DoSequence

call displayLeft
ld hl,SequenceOndulationRetour : call DoSequence
ld a,14 : ld (DoSequence.limiter+1),a
.mover1 ld hl,SequenceDosRetour : call DoSequence

xor a : ld (DoSequence.sens+1),a ; retournement figé
ld a,70 : ld (DoSequence.limiter+1),a ; next swim
call greyLineLeft
ld hl,SequenceRetournementLeft : call DoSequence

ld a,1 : ld (DoSequence.sens+1),a
call displayRight ; ??? enough ???
ld hl,SequenceOndulation : call DoSequence
ld a,#E9 : ld (DoSequence.limiter+1),a
.move2 ld hl,SequenceBreast : call DoSequence

xor a : ld (DoSequence.sens+1),a ; retournement figé
ld (DoSequence.limiter+1),a ; retour au début
ld hl,SequenceRetournementRight : call DoSequence

call displayLeft
ld hl,SequenceOndulationRetour : call DoSequence
ld a,14 : ld (DoSequence.limiter+1),a
.mover2 ld hl,SequenceCrawlRetour : call DoSequence

ld hl,#C9FB : ld (#38),hl ; stop TIMER
jp Ending


Medley200
ld e,70 : call InitSequence ; limiter=70
ld hl,SequencePlongeon : call DoSequence
ld hl,(spritePosition) : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for ondulation

;=== butterfly + backstroke==========

ld hl,SequenceOndulation : call DoSequence
;ld hl,(spritePosition) : ld de,-80 : add hl,de : rst 0 : rst 0 : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for crawl
ld a,#E9 : ld (DoSequence.limiter+1),a
ld hl,SequenceButter : call DoSequence

xor a : ld (DoSequence.sens+1),a ; retournement figé
ld (DoSequence.limiter+1),a ; retour au début
ld hl,SequenceRetournementRight : call DoSequence

call displayLeft
ld hl,SequenceOndulationDosRetour : call DoSequence
ld a,14 : ld (DoSequence.limiter+1),a
ld hl,(spritePosition) : ld de,-80 : add hl,de : rst 0 : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for backstroke
ld hl,SequenceDosRetour : call DoSequence
ld hl,(spritePosition) : rst 0 : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for backstroke1

;=== breaststroke + crawl =====================
xor a : ld (DoSequence.sens+1),a ; retournement figé
ld a,70 : ld (DoSequence.limiter+1),a ; next swim
call greyLineLeft
ld hl,SequenceRetournementLeft : call DoSequence

ld a,1 : ld (DoSequence.sens+1),a
call displayRight ; ??? enough ???
ld hl,SequenceOndulation : call DoSequence
ld a,#E9 : ld (DoSequence.limiter+1),a
;ld hl,(spritePosition) : ld de,-80 : add hl,de : rst 0 : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for backstroke
ld hl,SequenceBreast : call DoSequence
;ld hl,(spritePosition) : rst 0 : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for backstroke1

xor a : ld (DoSequence.sens+1),a ; retournement figé
ld (DoSequence.limiter+1),a ; retour au début
ld hl,SequenceRetournementRight : call DoSequence

call displayLeft
ld hl,SequenceOndulationRetour : call DoSequence
ld a,14 : ld (DoSequence.limiter+1),a
ld hl,(spritePosition) : ld de,-80 : add hl,de : rst 0 : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for backstroke
ld hl,SequenceCrawlRetour : call DoSequence
ld hl,(spritePosition) : rst 0 : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for backstroke1

ld hl,#C9FB : ld (#38),hl ; stop TIMER
jp Ending



Medley400
ld e,70 : call InitSequence ; limiter=70
ld hl,SequencePlongeon : call DoSequence
ld hl,(spritePosition) : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for ondulation

;=== butterfly ==========

ld hl,SequenceOndulation : call DoSequence
;ld hl,(spritePosition) : ld de,-80 : add hl,de : rst 0 : rst 0 : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for crawl
ld a,#E9 : ld (DoSequence.limiter+1),a
ld hl,SequenceButter : call DoSequence

xor a : ld (DoSequence.sens+1),a ; retournement figé
ld (DoSequence.limiter+1),a ; retour au début
ld hl,SequenceRetournementRight : call DoSequence

call displayLeft
ld hl,SequenceOndulationRetour : call DoSequence
ld a,14 : ld (DoSequence.limiter+1),a
ld hl,SequenceButterRetour : call DoSequence

;=== backstroke =====================
xor a : ld (DoSequence.sens+1),a ; retournement figé
ld a,70 : ld (DoSequence.limiter+1),a ; next swim
call greyLineLeft
ld hl,SequenceRetournementLeft : call DoSequence

ld a,1 : ld (DoSequence.sens+1),a
call displayRight ; ??? enough ???
ld hl,SequenceOndulationDos : call DoSequence
ld hl,(spritePosition) : ld de,-80 : add hl,de : rst 0 : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for backstroke
ld a,#E9 : ld (DoSequence.limiter+1),a
ld hl,SequenceDos : call DoSequence
ld hl,(spritePosition) : rst 0 : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for backstroke1

xor a : ld (DoSequence.sens+1),a ; retournement figé
ld (DoSequence.limiter+1),a ; retour au début
ld hl,SequenceRetournementRight : call DoSequence

call displayLeft
ld hl,SequenceOndulationDosRetour : call DoSequence
ld a,14 : ld (DoSequence.limiter+1),a
ld hl,(spritePosition) : ld de,-80 : add hl,de : rst 0 : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for backstroke
ld hl,SequenceDosRetour : call DoSequence
ld hl,(spritePosition) : rst 0 : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for backstroke1

;=== breaststroke =====================
xor a : ld (DoSequence.sens+1),a ; retournement figé
ld a,70 : ld (DoSequence.limiter+1),a ; next swim
call greyLineLeft
ld hl,SequenceRetournementLeft : call DoSequence

ld a,1 : ld (DoSequence.sens+1),a
call displayRight ; ??? enough ???
ld hl,SequenceOndulation : call DoSequence
;ld hl,(spritePosition) : ld de,-80 : add hl,de : rst 0 : rst 0 : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for crawl
ld a,#E9 : ld (DoSequence.limiter+1),a
ld hl,SequenceBreast : call DoSequence

xor a : ld (DoSequence.sens+1),a ; retournement figé
ld (DoSequence.limiter+1),a ; retour au début
ld hl,SequenceRetournementRight : call DoSequence

call displayLeft
ld hl,SequenceOndulationRetour : call DoSequence
ld a,14 : ld (DoSequence.limiter+1),a
ld hl,SequenceBreastRetour : call DoSequence


;=== crawl =====================
xor a : ld (DoSequence.sens+1),a ; retournement figé
ld a,70 : ld (DoSequence.limiter+1),a ; next swim
call greyLineLeft
ld hl,SequenceRetournementLeft : call DoSequence

ld a,1 : ld (DoSequence.sens+1),a
call displayRight ; ??? enough ???
ld hl,SequenceOndulation : call DoSequence
ld hl,(spritePosition) : ld de,-80 : add hl,de : rst 0 : rst 0 : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for crawl
ld a,#E9 : ld (DoSequence.limiter+1),a
ld hl,(spritePosition) : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for backstroke1
ld hl,SequenceCrawl : call DoSequence

xor a : ld (DoSequence.sens+1),a ; retournement figé
ld (DoSequence.limiter+1),a ; retour au début
ld hl,SequenceRetournementRight : call DoSequence

call displayLeft
ld hl,SequenceOndulationRetour : call DoSequence
ld a,14 : ld (DoSequence.limiter+1),a
ld hl,(spritePosition) : ld de,-80 : add hl,de : rst 0 : rst 0 : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for crawl
ld hl,SequenceCrawlRetour : call DoSequence
ld hl,(spritePosition) : rst 0 : rst 0 : rst 0 : ld (spritePosition),hl ; adjust for backstroke1

ld hl,#C9FB : ld (#38),hl ; stop TIMER
jp Ending




TrackLoad_LoadingCredits
defb 4 : defw #D0D4,#4000
defb 5 : defw #D0D4,#4000+1024*5
defb 6 : defw #D0D3,#4000+1024*10
defb 255

TrackLoad_Water
defb 6 : defw #D4D4,#4000
defb 7 : defw #D0D4,#4000+1024*1
defb 8 : defw #D0D4,#4000+1024*6
defb 9 : defw #D0D4,#4000+1024*11
defb 255

TrackLoad_BackGround
defb 10 : defw #D0D4,#4000
defb 11 : defw #D0D2,#4000+5*1024
defb 255


TrackLoadSPR_B4
defb 11 : defw #D3D4,#4000
defb 12 : defw #D0D4,#4000+1024*2
defb 13 : defw #D0D4,#4000+1024*7
defb 14 : defw #D0D3,#4000+1024*12
defb 255

TrackLoadSPR_B5
defb 14 : defw #D4D4,#4000
defb 15 : defw #D0D4,#4000+1024*1
defb 16 : defw #D0D4,#4000+1024*6
defb 17 : defw #D0D4,#4000+1024*11
defb 255

TrackLoadSPR_B6
defb 18 : defw #D0D4,#4000
defb 19 : defw #D0D4,#4000+1024*5
defb 20 : defw #D0D4,#4000+1024*10
defb 21 : defw #D0D0,#4000+1024*15
defb 255

TrackLoadSPR_B7
defb 21 : defw #D1D4,#4000
defb 22 : defw #D0D4,#4000+1024*4
defb 23 : defw #D0D4,#4000+1024*9 
defb 24 : defw #D0D1,#4000+1024*14
defb 255

TrackLoadWinnerLoser
defb 24 : defw #D2D4,#4000
defb 25 : defw #D0D4,#4000+3*1024
defb 26 : defw #D0D3,#4000+8*1024
defb 255

TrackLoadChampion
defb 30 : defw 0xD0D4,#4000
defb 39 : defw 0xD0D4,#4000+5*1024
defb 255

seqStart

; nombre de VBL, ajustement de ligne, ajustement de bloc, routine de sprite
SequencePlongeon
defb 2,{page}nageplongeon64x32_right_1 &0xFF: defw nageplongeon64x32_right_1
defb 2,{page}nageplongeon64x32_right_2 &0xFF: defw nageplongeon64x32_right_2
defb 2,{page}nageplongeon64x32_right_3 &0xFF: defw nageplongeon64x32_right_3
defb 2,{page}nageplongeon64x32_right_3 &0xFF: defw nageplongeon64x32_right_3
defb 2,{page}nageplongeon64x32_right_4 &0xFF: defw nageplongeon64x32_right_4
defb 2,{page}nageplongeon64x32_right_4 &0xFF: defw nageplongeon64x32_right_4
defb 2,{page}nageplongeon64x32_right_5 &0xFF: defw nageplongeon64x32_right_5
defb 2,{page}nageplongeon64x32_right_5 &0xFF: defw nageplongeon64x32_right_5
defb 2|#80 : defw 160 : defb {page}nageplongeon64x32_right_6&0xFF : defw nageplongeon64x32_right_6
defb 2,{page}nageplongeon64x32_right_6&0xFF : defw nageplongeon64x32_right_6
defb 2,{page}nageplongeon64x32_right_7&0xFF : defw nageplongeon64x32_right_7
defb 2,{page}nageplongeon64x32_right_7&0xFF : defw nageplongeon64x32_right_7
defb 2|#80 : defw 80 : defb {page}nageplongeon64x32_right_8&0xFF : defw nageplongeon64x32_right_8
defb 2,{page}nageplongeon64x32_right_8&0xFF : defw nageplongeon64x32_right_8
defb 2,{page}nageplongeon64x32_right_8&0xFF : defw nageplongeon64x32_right_8
defb 0,0

SequencePlongeonDos
defb 2,{page}nageplongeonDosSheet_right_1 &0xFF: defw nageplongeonDosSheet_right_1
defb 2,{page}nageplongeonDosSheet_right_2 &0xFF: defw nageplongeonDosSheet_right_2
defb 2,{page}nageplongeonDosSheet_right_3 &0xFF: defw nageplongeonDosSheet_right_3
defb 2,{page}nageplongeonDosSheet_right_3 &0xFF: defw nageplongeonDosSheet_right_3
defb 2,{page}nageplongeonDosSheet_right_4 &0xFF: defw nageplongeonDosSheet_right_4
defb 2,{page}nageplongeonDosSheet_right_4 &0xFF: defw nageplongeonDosSheet_right_4
defb 2,{page}nageplongeonDosSheet_right_5 &0xFF: defw nageplongeonDosSheet_right_5
defb 2,{page}nageplongeonDosSheet_right_5 &0xFF: defw nageplongeonDosSheet_right_5
defb 2,{page}nageplongeonDosSheet_right_6 &0xFF : defw nageplongeonDosSheet_right_6
defb 2,{page}nageplongeonDosSheet_right_6 &0xFF : defw nageplongeonDosSheet_right_6
defb 2,{page}nageplongeonDosSheet_right_7 &0xFF : defw nageplongeonDosSheet_right_7
defb 2,{page}nageplongeonDosSheet_right_7 &0xFF : defw nageplongeonDosSheet_right_7
defb 2,{page}nageplongeonDosSheet_right_8 &0xFF : defw nageplongeonDosSheet_right_8
defb 2,{page}nageplongeonDosSheet_right_8 &0xFF : defw nageplongeonDosSheet_right_8
defb 2,{page}nageplongeonDosSheet_right_8 &0xFF : defw nageplongeonDosSheet_right_8
defb 0,0


SequenceOndulationDos
defb 2,{page}nageondulationDOSsheet_right_0&0xFF : defw nageondulationDOSsheet_right_0
defb 2,{page}nageondulationDOSsheet_right_1&0xFF : defw nageondulationDOSsheet_right_1
defb 2,{page}nageondulationDOSsheet_right_2&0xFF : defw nageondulationDOSsheet_right_2
defb 2,{page}nageondulationDOSsheet_right_3&0xFF : defw nageondulationDOSsheet_right_3
defb 2,{page}nageondulationDOSsheet_right_4&0xFF : defw nageondulationDOSsheet_right_4
defb 2,{page}nageondulationDOSsheet_right_5&0xFF : defw nageondulationDOSsheet_right_5
defb 2,{page}nageondulationDOSsheet_right_6&0xFF : defw nageondulationDOSsheet_right_6
defb 2,{page}nageondulationDOSsheet_right_7&0xFF : defw nageondulationDOSsheet_right_7
defb 2,{page}nageondulationDOSsheet_right_8&0xFF : defw nageondulationDOSsheet_right_8
defb 0,1 : defw SequenceOndulationDos

SequenceOndulationDosRetour
defb 2,{page}nageondulationDOSsheet_left_0&0xFF : defw nageondulationDOSsheet_left_0
defb 2,{page}nageondulationDOSsheet_left_1&0xFF : defw nageondulationDOSsheet_left_1
defb 2,{page}nageondulationDOSsheet_left_2&0xFF : defw nageondulationDOSsheet_left_2
defb 2,{page}nageondulationDOSsheet_left_3&0xFF : defw nageondulationDOSsheet_left_3
defb 2,{page}nageondulationDOSsheet_left_4&0xFF : defw nageondulationDOSsheet_left_4
defb 2,{page}nageondulationDOSsheet_left_5&0xFF : defw nageondulationDOSsheet_left_5
defb 2,{page}nageondulationDOSsheet_left_6&0xFF : defw nageondulationDOSsheet_left_6
defb 2,{page}nageondulationDOSsheet_left_7&0xFF : defw nageondulationDOSsheet_left_7
defb 2,{page}nageondulationDOSsheet_left_8&0xFF : defw nageondulationDOSsheet_left_8
defb 0,1 : defw SequenceOndulationDosRetour

SequenceOndulation
defb 2,{page}nageondulationsheet_right_0&0xFF : defw nageondulationsheet_right_0
defb 2,{page}nageondulationsheet_right_1&0xFF : defw nageondulationsheet_right_1
defb 2,{page}nageondulationsheet_right_2&0xFF : defw nageondulationsheet_right_2
defb 2,{page}nageondulationsheet_right_3&0xFF : defw nageondulationsheet_right_3
defb 2,{page}nageondulationsheet_right_4&0xFF : defw nageondulationsheet_right_4
defb 2,{page}nageondulationsheet_right_5&0xFF : defw nageondulationsheet_right_5
defb 2,{page}nageondulationsheet_right_6&0xFF : defw nageondulationsheet_right_6
defb 2,{page}nageondulationsheet_right_7&0xFF : defw nageondulationsheet_right_7
defb 2,{page}nageondulationsheet_right_8&0xFF : defw nageondulationsheet_right_8
defb 0,1 : defw SequenceOndulation

SequenceOndulationRetour
defb 2,{page}nageondulationsheet_left_0&0xFF : defw nageondulationsheet_left_0
defb 2,{page}nageondulationsheet_left_1&0xFF : defw nageondulationsheet_left_1
defb 2,{page}nageondulationsheet_left_2&0xFF : defw nageondulationsheet_left_2
defb 2,{page}nageondulationsheet_left_3&0xFF : defw nageondulationsheet_left_3
defb 2,{page}nageondulationsheet_left_4&0xFF : defw nageondulationsheet_left_4
defb 2,{page}nageondulationsheet_left_5&0xFF : defw nageondulationsheet_left_5
defb 2,{page}nageondulationsheet_left_6&0xFF : defw nageondulationsheet_left_6
defb 2,{page}nageondulationsheet_left_7&0xFF : defw nageondulationsheet_left_7
defb 2,{page}nageondulationsheet_left_8&0xFF : defw nageondulationsheet_left_8
defb 0,1 : defw SequenceOndulationRetour

SequenceCrawl
defb 2,{page}nagecrawlsheet_right_0&0xFF : defw nagecrawlsheet_right_0
defb 2,{page}nagecrawlsheet_right_1&0xFF : defw nagecrawlsheet_right_1
defb 2,{page}nagecrawlsheet_right_2&0xFF : defw nagecrawlsheet_right_2
defb 2,{page}nagecrawlsheet_right_3&0xFF : defw nagecrawlsheet_right_3
defb 2,{page}nagecrawlsheet_right_4&0xFF : defw nagecrawlsheet_right_4
defb 2,{page}nagecrawlsheet_right_5&0xFF : defw nagecrawlsheet_right_5
defb 2,{page}nagecrawlsheet_right_6&0xFF : defw nagecrawlsheet_right_6
defb 2,{page}nagecrawlsheet_right_7&0xFF : defw nagecrawlsheet_right_7
defb 2,{page}nagecrawlsheet_right_8&0xFF : defw nagecrawlsheet_right_8
defb 0,1 : defw SequenceCrawl

SequenceRetournementLeft
defb 3,{page}NageRetournementSheet_Left_0&0xFF : defw NageRetournementSheet_Left_0
defb 3,{page}NageRetournementSheet_Left_1&0xFF : defw NageRetournementSheet_Left_1
defb 3,{page}NageRetournementSheet_Left_2&0xFF : defw NageRetournementSheet_Left_2
defb 3,{page}NageRetournementSheet_Left_3&0xFF : defw NageRetournementSheet_Left_3
defb 3,{page}NageRetournementSheet_Left_4&0xFF : defw NageRetournementSheet_Left_4
defb 3,{page}NageRetournementSheet_Left_5&0xFF : defw NageRetournementSheet_Left_5
defb 3,{page}NageRetournementSheet_Left_6&0xFF : defw NageRetournementSheet_Left_6
defb 0,0

SequenceRetournementRight
defb 3,{page}NageRetournementSheet_Right_0&0xFF : defw NageRetournementSheet_Right_0
defb 3,{page}NageRetournementSheet_Right_1&0xFF : defw NageRetournementSheet_Right_1
defb 3,{page}NageRetournementSheet_Right_2&0xFF : defw NageRetournementSheet_Right_2
defb 3,{page}NageRetournementSheet_Right_3&0xFF : defw NageRetournementSheet_Right_3
defb 3,{page}NageRetournementSheet_Right_4&0xFF : defw NageRetournementSheet_Right_4
defb 3,{page}NageRetournementSheet_Right_5&0xFF : defw NageRetournementSheet_Right_5
defb 3,{page}NageRetournementSheet_Right_6&0xFF : defw NageRetournementSheet_Right_6
defb 0,0

SequenceCrawlRetour
defb 2,{page}nagecrawlsheet_left_0&0xFF : defw nagecrawlsheet_left_0
defb 2,{page}nagecrawlsheet_left_1&0xFF : defw nagecrawlsheet_left_1
defb 2,{page}nagecrawlsheet_left_2&0xFF : defw nagecrawlsheet_left_2
defb 2,{page}nagecrawlsheet_left_3&0xFF : defw nagecrawlsheet_left_3
defb 2,{page}nagecrawlsheet_left_4&0xFF : defw nagecrawlsheet_left_4
defb 2,{page}nagecrawlsheet_left_5&0xFF : defw nagecrawlsheet_left_5
defb 2,{page}nagecrawlsheet_left_6&0xFF : defw nagecrawlsheet_left_6
defb 2,{page}nagecrawlsheet_left_7&0xFF : defw nagecrawlsheet_left_7
defb 2,{page}nagecrawlsheet_left_8&0xFF : defw nagecrawlsheet_left_8
defb 0,1 : defw SequenceCrawlRetour

SequenceBreast
defb 2,{page}nagebrassesheet_right_0&0xFF : defw nagebrassesheet_right_0
defb 2,{page}nagebrassesheet_right_1&0xFF : defw nagebrassesheet_right_1
defb 2,{page}nagebrassesheet_right_2&0xFF : defw nagebrassesheet_right_2
defb 2,{page}nagebrassesheet_right_3&0xFF : defw nagebrassesheet_right_3
defb 2,{page}nagebrassesheet_right_4&0xFF : defw nagebrassesheet_right_4
defb 2,{page}nagebrassesheet_right_5&0xFF : defw nagebrassesheet_right_5
defb 2,{page}nagebrassesheet_right_6&0xFF : defw nagebrassesheet_right_6
defb 2,{page}nagebrassesheet_right_7&0xFF : defw nagebrassesheet_right_7
defb 2,{page}nagebrassesheet_right_8&0xFF : defw nagebrassesheet_right_8
defb 0,1 : defw SequenceBreast

SequenceBreastRetour
defb 2,{page}nagebrassesheet_left_0&0xFF : defw nagebrassesheet_left_0
defb 2,{page}nagebrassesheet_left_1&0xFF : defw nagebrassesheet_left_1
defb 2,{page}nagebrassesheet_left_2&0xFF : defw nagebrassesheet_left_2
defb 2,{page}nagebrassesheet_left_3&0xFF : defw nagebrassesheet_left_3
defb 2,{page}nagebrassesheet_left_4&0xFF : defw nagebrassesheet_left_4
defb 2,{page}nagebrassesheet_left_5&0xFF : defw nagebrassesheet_left_5
defb 2,{page}nagebrassesheet_left_6&0xFF : defw nagebrassesheet_left_6
defb 2,{page}nagebrassesheet_left_7&0xFF : defw nagebrassesheet_left_7
defb 2,{page}nagebrassesheet_left_8&0xFF : defw nagebrassesheet_left_8
defb 0,1 : defw SequenceBreastRetour

SequenceButter
defb 2,{page}nagepapillonsheet_right_0&0xFF : defw nagepapillonsheet_right_0
defb 2,{page}nagepapillonsheet_right_1&0xFF : defw nagepapillonsheet_right_1
defb 2,{page}nagepapillonsheet_right_2&0xFF : defw nagepapillonsheet_right_2
defb 2,{page}nagepapillonsheet_right_3&0xFF : defw nagepapillonsheet_right_3
defb 2,{page}nagepapillonsheet_right_4&0xFF : defw nagepapillonsheet_right_4
defb 2,{page}nagepapillonsheet_right_5&0xFF : defw nagepapillonsheet_right_5
defb 2,{page}nagepapillonsheet_right_6&0xFF : defw nagepapillonsheet_right_6
defb 2,{page}nagepapillonsheet_right_7&0xFF : defw nagepapillonsheet_right_7
defb 2,{page}nagepapillonsheet_right_8&0xFF : defw nagepapillonsheet_right_8
defb 0,1 : defw SequenceButter

SequenceButterRetour
defb 2,{page}nagepapillonsheet_left_0&0xFF : defw nagepapillonsheet_left_0
defb 2,{page}nagepapillonsheet_left_1&0xFF : defw nagepapillonsheet_left_1
defb 2,{page}nagepapillonsheet_left_2&0xFF : defw nagepapillonsheet_left_2
defb 2,{page}nagepapillonsheet_left_3&0xFF : defw nagepapillonsheet_left_3
defb 2,{page}nagepapillonsheet_left_4&0xFF : defw nagepapillonsheet_left_4
defb 2,{page}nagepapillonsheet_left_5&0xFF : defw nagepapillonsheet_left_5
defb 2,{page}nagepapillonsheet_left_6&0xFF : defw nagepapillonsheet_left_6
defb 2,{page}nagepapillonsheet_left_7&0xFF : defw nagepapillonsheet_left_7
defb 2,{page}nagepapillonsheet_left_8&0xFF : defw nagepapillonsheet_left_8
defb 0,1 : defw SequenceButterRetour

SequenceDos
defb 2,{page}nagedossheet_right_0&0xFF : defw nagedossheet_right_0
defb 2,{page}nagedossheet_right_1&0xFF : defw nagedossheet_right_1
defb 2,{page}nagedossheet_right_2&0xFF : defw nagedossheet_right_2
defb 2,{page}nagedossheet_right_3&0xFF : defw nagedossheet_right_3
defb 2,{page}nagedossheet_right_4&0xFF : defw nagedossheet_right_4
defb 2,{page}nagedossheet_right_5&0xFF : defw nagedossheet_right_5
defb 2,{page}nagedossheet_right_6&0xFF : defw nagedossheet_right_6
defb 2,{page}nagedossheet_right_7&0xFF : defw nagedossheet_right_7
defb 2,{page}nagedossheet_right_8&0xFF : defw nagedossheet_right_8
defb 0,1 : defw SequenceDos

SequenceDosRetour
defb 2,{page}nagedossheet_left_0&0xFF : defw nagedossheet_left_0
defb 2,{page}nagedossheet_left_1&0xFF : defw nagedossheet_left_1
defb 2,{page}nagedossheet_left_2&0xFF : defw nagedossheet_left_2
defb 2,{page}nagedossheet_left_3&0xFF : defw nagedossheet_left_3
defb 2,{page}nagedossheet_left_4&0xFF : defw nagedossheet_left_4
defb 2,{page}nagedossheet_left_5&0xFF : defw nagedossheet_left_5
defb 2,{page}nagedossheet_left_6&0xFF : defw nagedossheet_left_6
defb 2,{page}nagedossheet_left_7&0xFF : defw nagedossheet_left_7
defb 2,{page}nagedossheet_left_8&0xFF : defw nagedossheet_left_8
defb 0,1 : defw SequenceDosRetour




print 'definition des sequences = ',$-seqStart

;*******************************************************************************
                              InitSequence
;*******************************************************************************
ld a,1 : ld (DoSequence.sens+1),a
ld a,e : ld (DoSequence.limiter+1),a
ret

;*******************************************************************************
                                mustQuit
;*******************************************************************************
inc hl : ld a,(hl) : inc hl : or a : ret z ; quit
ld a,(hl) : inc hl : ld h,(hl) : ld l,a
;*******************************************************************************
                               DoSequence
;*******************************************************************************
; 0,0 => quit
; 0,1,<addr> => reinit to addr
ld a,(hl) : or a : jr z,mustQuit : and 15 : ld e,a : dec e : jr z,.doLastVBL
.doVBL call fullvbl : dec e : jr nz,.doVBL
.doLastVBL call vbl

ld a,(posx) : .limiter cp 70 : ret z ; limit
.sens add #1
ld (posx),a

exx : call displayWaves : exx

ld a,(hl) : inc hl : and #80 : jr z,.noAdjust
ld a,(hl) : inc hl : exa
ld a,(hl) : inc hl
exx : ld hl,(spritePosition) : ld d,a : exa : ld e,a : add hl,de : ld (spritePosition),hl : exx
.noAdjust

ld a,(hl) : ld (.spriteRAM+1),a : inc hl ; page

;ld a,(hl) : inc hl : exx
;ld hl,(spritePosition)
;or a : jr z,.noFineAdjust : ld e,a
;.FineAdjust rst 0 : dec e : jr nz,.FineAdjust

ld e,(hl) : inc hl
ld d,(hl) : inc hl : ld (.spriteCall+1),de
exx
ld hl,(spritePosition)
.spriteRAM ld bc,#7F00 : call SetRAM
.spriteCall call #1234
call flipScreen

ld a,r : srl a : and 3 : add #14 : ld l,a : ld h,6 : call SendPSG
ld a,r : srl a : and 2 : dec a : .curVolume add 13
and 15
cp 12 : jr nc,.infOK : ld a,12 : .infOK
ld l,a : ld h,9 : call SendPSG

exx
jp DoSequence

TimerData
chronom   defb 0
chronos10 defb 0
chronos1  defb 0
chrono10  defb 0
chrono100 defb 0
strikeCounter defw 0
TimerEndData
keyboardfusion defb #FF

TimerHandler
push af,bc,de,hl
call scanFusion
ld a,(keyboardfusion) : .lastFusion cp 0 : jr z,.ticker : ld (.lastFusion+1),a
ld hl,(strikeCounter) : inc hl : ld (strikeCounter),hl

.ticker ld a,3 ; 3 ticks => 1/100s
dec a
jr nz,.endDiff

ld hl,chrono100 : ld a,(hl) : inc a : ld (hl),a : cp 10 : jr nz,.endChrono : ld (hl),0 : dec hl
ld a,(hl) : inc a : ld (hl),a : cp 10 : jr nz,.endChrono : ld (hl),0 : dec hl
ld a,(hl) : inc a : ld (hl),a : cp 10 : jr nz,.endChrono : ld (hl),0 : dec hl
ld a,(hl) : inc a : ld (hl),a : cp 6  : jr nz,.endChrono : ld (hl),0 : dec hl
ld a,(hl) : inc a : ld (hl),a
.endChrono

ld a,3
.endDiff
ld (.ticker+1),a


pop hl,de,bc,af
ei:ret


Ending
ld hl,#090D : call SendPSG
call fullvbl3 : call displayWaves : ld hl,(spritePosition) : ld bc,{page}NageEndingNewSheet1_Left_0 : call setRam : call NageEndingNewSheet1_Left_0 : call flipScreen ;: ld hl,(spritePosition) : inc hl : ld (spritePosition),hl
call fullvbl3 : call displayWaves : ld hl,(spritePosition) : ld bc,{page}NageEndingNewSheet1_Left_1 : call setRam : call NageEndingNewSheet1_Left_1 : call flipScreen ;: ld hl,(spritePosition) : inc hl : ld (spritePosition),hl
call fullvbl3 : call displayWaves : ld hl,(spritePosition) : ld bc,{page}NageEndingNewSheet1_Left_2 : call setRam : call NageEndingNewSheet1_Left_2 : call flipScreen ;: ld hl,(spritePosition) : ld de,3 : add hl,de : ld (spritePosition),hl
call fullvbl3 : call displayWaves : ld hl,(spritePosition) : ld bc,{page}NageEndingNewSheet2_Left_0 : call setRam : call NageEndingNewSheet2_Left_0 : call flipScreen ;: ld hl,(spritePosition) : ld de,3 : add hl,de : ld (spritePosition),hl
.reloop
call fullvbl5 : call displayWaves : ld hl,(spritePosition) : ld bc,{page}NageEndingNewSheet2_Left_1 : call setRam : call NageEndingNewSheet2_Left_1 : call flipScreen : call endingkey
call fullvbl5 : call displayWaves : ld hl,(spritePosition) : ld bc,{page}NageEndingNewSheet2_Left_2 : call setRam : call NageEndingNewSheet2_Left_2 : call flipScreen : call endingkey
call fullvbl5 : call displayWaves : ld hl,(spritePosition) : ld bc,{page}NageEndingNewSheet2_Left_3 : call setRam : call NageEndingNewSheet2_Left_3 : call flipScreen : call endingkey
call fullvbl5 : call displayWaves : ld hl,(spritePosition) : ld bc,{page}NageEndingNewSheet2_Left_2 : call setRam : call NageEndingNewSheet2_Left_2 : call flipScreen : call endingkey
jr .reloop

EndingKey
call scankeyboard
xor a : ld hl,keyboardmap : ld b,10
.scan or (hl) : inc hl : djnz .scan
or a : ret z

ld hl,palette_black : call setPalette

ld a,(flipScreen.addr+1) : cp #30 : jr nz,.noflip : call displayWaves : call flipscreen
.noflip
ld hl,#0700+%111111 : call SendPSG
ld sp,#100 ; unstack everything
ld a,(#36) : or a : jp z,InitMenu
jp Olympics.return

spritePosition defw #8000+28+13*80

fullvbl3 ld e,3 : jr fullvbl5.loop
fullvbl5 ld e,5 : .loop call fullvbl : dec e : jr nz,.loop : ret
flipScreen call vbl
.addr ld a,#20 : xor #10 : ld (.addr+1),a : ld bc,#BC00+12 : out (c),c : inc b : out (c),a : ret


avancePiscine ld a,(posx) : inc a : ld (posx),a : call displayWaves : ld hl,(spritePosition) : ret

MainLoop1
ld b,#F5 : in a,(c) : rra : jr nc,MainLoop1
call displayWaves : ld a,(posx) : inc a : cp 239 : ld (posx),a : jr z,MainLoop2
ld hl,#C000+38+12*80 : ld bc,{page}nageplongeon64x32_right_0 : call setRam : call nageplongeon64x32_right_0
jr MainLoop1

MainLoop2
ld b,#F5 : in a,(c) : rra : jr nc,MainLoop2
call displayWaves : ld a,(posx) : dec a : ld (posx),a : jr z,MainLoop1
ld hl,#C000+38+12*80 : ld bc,{page}nageplongeon64x32_right_0 : call setRam : call nageplongeon64x32_right_0
jr MainLoop2



SendPSG
ld a,#C0
ld bc,#F4F4 : out (c),h
ld b,#F6 : out (c),a : out (c),0
ld b,c : out (c),l
ld b,#F6 : add a : out (c),a : out (c),0
ret


vbl ld b,#F5
.loop in a,(c) : rra : jr nc,.loop : ret
fullvbl call vbl
novbl ld b,#F5
.loop in a,(c) : rra : jr c,.loop : ret

SetRAM ld (.restore+1),bc : out (c),c : ret
.restore ld bc,#7FC0 : out (c),c : ret

palette_black   defs 16,#54
palette_titre   defb #54,#5C,#44,#56,#58,#40,#4C,#55,#52,#57,#45,#4E,#4A,#43,#5B,#4B,#54
palette_ingame  defb #54,#5C,#44,#56,#58,#40,#55,#4C,#52,#57,#4E,#45,#47,#4A,#5B,#4B
palette_credits defb #54,#5C,#44,#56,#58,#40,#55,#4C,#52,#4E,#57,#47,#4A,#5B,#4B,#4F,#54 ; winner/loser/champion


setPalette
ld b,#7F : ld e,0 : ld a,17
.setTitle out (c),e : inc e : inc b : outi : dec a : jr nz,.setTitle : ret

include 'trackload.asm'

include 'keyboard.asm'

include 'race.asm'

beep incbin 'sample_beep_7800.wav',SM2 : beep_end

digits incbin './assets/timerDigits.bin'

include 'dzx0_standard.asm'
unzx0 dzx0_standard (void)


fontBlack  incbin './assets/LeonFontBlack.bin'
fontBlue   incbin './assets/LeonFontBlue.bin'
fontRed    incbin './assets/LeonFontRed.bin'
fontGreen  incbin './assets/LeonFontGreen.bin'

include './zik/ingame_playerconfig.asm'
include './zik/playerAKG.asm'
muzak include './zik/ingame.asm'

print 'Fin du moteur en RAM : ',{hex}$

edsk create,'LeonMarchand.dsk',DATA,42,OVERWRITE
edsk drop,'LeonMarchand.dsk','2-41'
edsk add,'LeonMarchand.dsk','2-41:0xD0-0xD4',3 ; 5K par piste

edsk writesect,'LeonMarchand.dsk',0,$,'35:0xD0-0xD4 36:0xD0-0xD4 37:0xD0-0xD4 38:0xD1'


include './assets/dispatch.asm'




;bank : org 0 : incbin './assets/EcranTitre.zx0' : edsk writesect,'LeonMarchand.dsk',0,#4000,'8:0xD3-0xD4 9:0xD0-0xD4' ; 7K

; intro

bank
org #4000
InGameWaterScroll
incbin './assets/piscine640.bin'
InGameWaterScrollDown
incbin './assets/piscine640down.bin',0,23*320

edsk writesect,'LeonMarchand.dsk',#4000,#4000,'6:0xD4 7:0xD0-0xD4 8:0xD0-0xD4 9:0xD0-0xD4' ; 16K not crunched

bank
org #4000
background incbin './assets/InGameBackGround.zx0'
takeremove inczx0 './assets/TakeYourMarksSpriteRemoveY13.bin'
takemarks  inczx0 './assets/TakeYourMarksSpriteY13.bin'
takesample incbin 'sample_take_7800c.wav',SM2
takeTmp
print 'background+take+sample = ',$-#4000

edsk writesect,'LeonMarchand.dsk',#4000,takeTmp-#4000,'10:0xD0-0xD4 11:0xD0-0xD2' ; 8K


bank 4 : edsk writesect,'LeonMarchand.dsk',#4000,#4000,'11:0xD3-0xD4 12:0xD0-0xD4 13:0xD0-0xD4 14:0xD0-0xD3' ; 16K
bank 5 : edsk writesect,'LeonMarchand.dsk',#4000,#4000,'14:0xD4-0xD4 15:0xD0-0xD4 16:0xD0-0xD4 17:0xD0-0xD4' ; 16K
bank 6 : edsk writesect,'LeonMarchand.dsk',#4000,#4000,'18:0xD0-0xD4 19:0xD0-0xD4 20:0xD0-0xD4 21:0xD0-0xD0' ; 16K
bank 7 : edsk writesect,'LeonMarchand.dsk',#4000,#4000,'21:0xD1-0xD4 22:0xD0-0xD4 23:0xD0-0xD4 24:0xD0-0xD1' ; 16K

bank : org #4000 : leonWinner incbin './assets/LeonWinner.zx0' : leonLoser incbin './assets/LeonLoser.zx0'
edsk writesect,'LeonMarchand.dsk',#4000,$-#4000,'24:0xD2-0xD4 25:0xD0-0xD4 26:0xD0-0xD3' ; 12K

bank : org #4000 : leonChampion incbin './assets/LeonChampion.zx0'
org #4000+5*1024
endMusic incbin './zik/endingMusic.bin'
endPlayer=#5D6E
edsk writesect,'LeonMarchand.dsk',#4000,$-#4000,'30:0xD0-0xD4 39:0xD0-0xD4' ; 5K en piste 30 au loin ^_^ + 5K ending music


bank : 
incbin './assets/LeonLoading.zx0'
org #1000
incbin './assets/EcranCredits.zx0'
org 1024*10
incbin './assets/LeonPompesSheet.bin'
edsk writesect,'LeonMarchand.dsk',0,$,'4:0xD0-0xD4 5:0xD0-0xD4 6:0xD0-0xD3' ; less than 4K+6K crunched + 4K pompes


;--- intro ----------------------------------------------------------------
bank : org #4000
incbin './assets/IntroDecor160.zx0' ; 5K
edsk writesect,'LeonMarchand.dsk',#4000,$-#4000,'32:0xD0-0xD4'

bank : org #4000
sp1z incbin './assets/IntroSpriteSheet1.zx0'
sp2z incbin './assets/IntroSpriteSheet2.zx0'
edsk writesect,'LeonMarchand.dsk',#4000,$-#4000,'31:0xD0-0xD4'  ; 5K

bank : org #4000
EcranTitre incbin './assets/EcranTitre.zx0' ; 7K
edsk writesect,'LeonMarchand.dsk',#4000,$-#4000,'33:0xD0-0xD4 34:0xD0-0xD1'


bank
include 'CAT_C1.asm'
include 'CAT_C2.asm'
edsk writesect,'LeonMarchand.dsk',0,$,'0:0xC1-0xC2'

bank
incbin 'LEON.BIN'
edsk writesect,'LeonMarchand.dsk',0,$,'0:0xC5-0xC9 1:0xC1-0xC5'

