











displayWaves

.borderLeft ld a,#85 : xor #40 : ld (.borderLeft+1),a : ld h,a


ld a,(DoSequence.sens+1) : inc a : jr nz,.depLeft
ld a,(posx) : cp #25 : jr z,.oneGrey : jr c,.twogrey : jr .noLeft

.oneGrey
ld b,36
ld l,#A0
ld c,#F0
.traceOneGrey
ld (hl),c : rst 0
djnz .traceOneGrey
jp .noRight
.twoGrey
ld b,18
ld e,a : ld a,#24 : sub e : add #A0 : ld l,a
ld c,#F0
.traceTwoGrey
ld (hl),c : inc hl : ld (hl),c : rst 0
ld (hl),c : dec hl : ld (hl),c : rst 0
djnz .traceTwoGrey
jp .noRight


;******************************************************************
.depLeft
ld a,(posx) : cp #2E : jp nc,.noLeft
add -9
ld e,a : ld a,#BD : sub e : ld l,a ; HL=adresse ou balancer le bleu

;ld a,(DoSequence.sens+1) : 

ld b,18 ; 56=28x2
ld c,#3C
.traceLeft
ld (hl),c : inc hl : ld (hl),c : rst 0
ld (hl),c : dec hl : ld (hl),c : rst 0
djnz .traceLeft
jp .noRight

.noLeft
;ld a,(DoSequence.sens+1) : inc a : jr nz,.rightBorder

.rightBorder
cp #C8 : jr z,.trace3sens
cp #C9 : jr z,.traceRightOne
cp #CA : jr c,.noRight

neg : add #CA : add #EE : .rc3 add 0 : ld l,a ; adresse ou balancer le béton / pour l'eau c'est du coup un octet avant!

ld b,18
.rc1 ld c,#F0
.traceRight
ld (hl),c : inc hl : ld (hl),c : rst 0
ld (hl),c : dec hl : ld (hl),c : rst 0
djnz .traceRight
jr .noRight

.trace3sens
ld a,(.rc3+1) : or a : jr z,.noRight
.disp3
ld b,18
ld c,#3C
ld l,#ED
.traceRight3
ld (hl),c : inc hl : ld (hl),c : inc hl : ld (hl),c : rst 0
ld (hl),c : dec hl : ld (hl),c : dec hl : ld (hl),c : rst 0
djnz .traceRight3
jr .noRight


.traceRightOne
ld a,(.rc3+1) : or a : jr nz,.disp3

ld l,#EF : .rc2 ld c,#F0 : ld b,28
.traceOne ld (hl),c : rst 0 : ld (hl),c : rst 0 : djnz .traceOne

.noRight

;******************************************************************


.ref1 ld hl,#8D50-80*4+46 : ld a,h : xor #40 : ld h,a : ld (.razsp+1),hl : ld (.ref1+1),hl
.ref2 ld hl,#8D50-80*2 : ld a,h : xor #40 : ld h,a : ld (.posW+1),hl : ld (.ref2+1),hl
ld a,(spritePosition+1) : xor #40 : ld (spritePosition+1),a

.ref3 ld hl,#85CE : ld a,h : xor #40 : ld h,a : ld (.ref3+1),hl

di
ld (.backspdown+1),sp
ld bc,#3C3C
ld d,18+14 ; pour les pieds du gars une fois à l'arrêt => désactivable à la demande si besoin de CPU
ld a,(posx) : cp #E0 : jr c,.razDown : sla d
.razDown
ld (.razDownStart+1),hl
ld sp,hl : repeat 9 : push bc : rend
dec d : jr z,.backspdown
.razDownStart ld hl,#1234 : ld a,h : add 8 : ld h,a : and #38 : jr nz,.razDown
ld a,h : sub #40 : ld h,a : ld a,l : add 80 : ld l,a : jr nc,.razDown
inc h : jr .razDown

.backspdown ld sp,#1234
ei

di
ld (.backsp+1),sp
ld d,16
ld bc,#F0F0
.razsp ld hl,0
.razline
ld (.razstart+1),hl
ld sp,hl
repeat 10 : push bc : rend
dec d : jr z,.backsp
.razstart ld hl,#1234 : ld a,h : add 8 : ld h,a : and #38 : jr nz,.razline
ld a,h : sub #40 : ld h,a : ld a,l : add 80 : ld l,a : jr nc,.razline
inc h : jr .razline

.backsp ld sp,#1234
ei

ld bc,#7FC0 : call SetRAM ; water in BANK 1
ld hl,inGameWaterScroll
ld bc,0 : posx=$-2 ; position ingame de 0 à 639-80 (???), on démarre une course à zéro
add hl,bc
.posW ld de,0
ld xl,23

.traceLine push hl,de : ldi 80 : pop de
 
ld a,d : add 8 : ld d,a : and #38 : jr nz,.next
ld a,d : sub #40 : ld d,a : ld a,e : add 80 : ld e,a : jr nc,.next
inc d : .next

pop hl : ld bc,320 : add hl,bc
dec xl
jp nz,.traceLine


ZeDown
.refd ld hl,#8D50+80*5 : ld a,h : xor #40 : ld h,a : ld (.posWD+1),hl : ld (.refd+2),a

ld hl,inGameWaterScrolldown
ld bc,(posx)
add hl,bc
.posWD ld de,0
ld xl,23
.traceLine push hl,de : ldi 80 : pop de
 
ld a,d : add 8 : ld d,a : and #38 : jr nz,.next
ld a,d : sub #40 : ld d,a : ld a,e : add 80 : ld e,a : jr nc,.next
inc d : .next

pop hl : ld bc,320 : add hl,bc
dec xl
jp nz,.traceLine

displayChrono
ld de,#82A1 : ld a,d : xor #40 : ld d,a : ld (displayChrono+2),a
ld ix,TimerData

ld a,(ix+0) : call displayDigit
ld a,10     : call displayDigit
ld a,(ix+1) : call displayDigit
ld a,(ix+2) : call displayDigit
ld a,10     : call displayDigit
ld a,(ix+3) : call displayDigit
ld a,(ix+4) : call displayDigit

;==============================================
ld a,(#37) : or a : jr nz,.Cheat
;==============================================
ld hl,(strikeCounter)
ld a,h : or l : call z,fullvbl3
ld a,l : cp 3 : jr nc,.NoZero
ld a,4 : sub l : ld e,a
.waitVBL call fullvbl : dec e : jr nz,.waitVBL
jr .noZero

.Cheat
call fullvbl

.noZero
ld hl,0 : ld (strikeCounter),hl
ret

displayDigit 
push de 
add a : ld b,a : add a : add b : add a : add b : ld hl,digits : add l : ld l,a : ld a,h : adc 0 : ld h,a
ld b,7
.dispsp ld a,(hl) : ld (de),a : inc hl : inc de : ld a,(hl) : inc hl : ld (de),a : dec de : ex hl,de : rst 0 : ex hl,de : djnz .dispsp
pop de : inc de : inc de
ret
