
buildsna

bankset 0

org 0
ld a,h : add 8 : ld h,a : and #38 : ret nz
ld a,h : sub #40 : ld h,a : ld a,l : add 80 : ld l,a : ret nc
inc h
ret

org #38
ei:ret

run entry
org #8000
entry
di
ld sp,#100
ld hl,#C9FB : ld (#38),hl
ld hl,rst000
ld de,0
ld bc,rst000end-rst000+1
ldir
ld bc,#7F80+%1110 : out (c),c
ld bc,#7F10 : out (c),c : ld a,#54 : out (c),a
ld bc,#7F00 : out (c),c : ld a,#54 : out (c),a
inc c : out (c),c : out (c),a

call MotorON : ld bc,#7FC0 : out (c),c : ld iy,TrackLoad_Data       : call ReadSequence
               ld bc,#7FC4 : out (c),c : ld iy,TrackLoad_EcranTitre : call ReadSequence : call MotorOFF
di

ld bc,#7FC0 : out (c),c
ld hl,#4000-5*1024
ld de,#C000
call unzx0

ld hl,#4000
ld de,#1000
call unzx0

ld a,0:ld hl,muzik
call PLY_AKG_INIT

call fullvbl
ld bc,#7F80+%1100 : out (c),c
ld hl,pal
ld bc,#7F00
xor a
.setpal out (c),a : inc a : inc b : outi : cp 16 : jr nz,.setpal


introspr=#1000

ld b,35
mire
push bc
call fullvbl : call fullvbl : ld hl,introspr         : call display_sprite
call fullvbl : call fullvbl : ld hl,introspr+21*60   : call display_sprite
call fullvbl : call fullvbl : ld hl,introspr+21*60*2 : call display_sprite
pop bc : djnz mire

call PLY_AKG_STOP
ld a,1:ld hl,muzik
call PLY_AKG_INIT

call fullvbl : ld hl,introspr+21*60*3 : call display_sprite : ld a,2 : call waits
call fullvbl : ld hl,introspr+21*60*4 : call display_sprite : ld a,2 : call waits
call fullvbl : ld hl,introspr+21*60*5 : call display_sprite : ld a,2 : call waits
call fullvbl : ld hl,introspr+21*60*6 : call display_sprite : ld a,2 : call waits

;ld hl,introspr+21*60*7 : ld de,#4000 : ld bc,21*60*2 : ldir ; screen shutdown en #4000 => no backup
ld a,60 : ld (waits.sync+1),a
ld a,2 : call waits

call PLY_AKG_STOP
ld hl,sp2z : ld de,#1000 : call unzx0
ld a,2:ld hl,muzik
call PLY_AKG_INIT

swim=#1000

swimloop
call fullvbl3 : ld hl,swim+21*60*0 : call display_sprite
call fullvbl3 : ld hl,swim+21*60*1 : call display_sprite
call fullvbl3 : ld hl,swim+21*60*2 : call display_sprite
call fullvbl3 : ld hl,swim+21*60*3 : call display_sprite
call fullvbl3 : ld hl,swim+21*60*4 : call display_sprite
call fullvbl3 : ld hl,swim+21*60*5 : call display_sprite
call fullvbl3 : ld hl,swim+21*60*6 : call display_sprite
call fullvbl3 : ld hl,swim+21*60*7 : call display_sprite
call fullvbl3 : ld hl,swim+21*60*8 : call display_sprite
.again ld a,20 : dec a : ld (.again+1),a : jr nz,swimloop

ld hl,#4000
ld de,#1000
call unzx0
ld hl,swim+21*60*7 : call display_sprite : call fullvbl5
ld hl,swim+21*60*8 : call display_sprite : call fullvbl5
ld hl,#1000:ld de,#1001:ld bc,60*21:ldir
ld hl,swim : call display_sprite

ld bc,#7F80+%1110 : out (c),c
ld bc,#7F10 : out (c),c : ld a,#54 : out (c),a
ld bc,#7F00 : out (c),c : ld a,#54 : out (c),a
inc c : out (c),c : out (c),a

ld bc,#7FC4 : out (c),c
ld hl,#4000
ld de,#C000
call unzx0

ld a,1 : call waits

; palette

ld bc,#7F80+%1100 : out (c),c
ld e,1
.fondu
ld hl,palette_titre
ld bc,#7F00
xor a
.setpal out (c),a : inc a : inc b : outi : cp e : jr z,.couic : cp 16 : jr nz,.setpal
cp 16 : jr z,.endcouic
.couic
dec hl : out (c),a : inc a: inc b : outi : cp 17 : jr c,.couic
.endcouic
push de : call fullvbl : pop de
inc e : ld a,17 : cp e : jr nz,.fondu


touche call fullvbl
call scankeyboard
ld b,10:ld hl,keyboardmap:xor a
.testk or (hl) : inc hl : djnz .testk
or a
jr z,touche
call PLY_AKG_STOP
di
ld sp,waits
call MotorON : ld bc,#7FC0 : out (c),c : ld iy,TrackLoad_Menu  : call ReadSequence : call MotorOFF
jp #100


palette_titre   defb #54,#5C,#44,#56,#58,#40,#4C,#55,#52,#57,#45,#4E,#4A,#43,#5B,#4B,#54,#54

display_sprite
ld de,58/2+#800*2+8*80+#C000
ld xl,60
.sprline push de : ld bc,21 : ldir : pop de : ex hl,de : rst 0 : ex hl,de : dec xl : jr nz,.sprline
ret

waits
push af
.sync ld h,64 : .une push hl : call fullvbl : pop hl : dec h : jr nz,.une
pop af
dec a : jr nz,waits
ret

fullvbl3 ld h,3 : jr fullvbl5.h5
fullvbl5
ld h,5 : .h5 push hl : call fullvbl : pop hl : dec h : jr nz,.h5
ret
fullvbl
ld b,#F5 : .vbl in a,(c) : rra : jr nc,.vbl
         .novbl in a,(c) : rra : jr c,.novbl
jp PLY_AKG_PLAY


pal defb #54,#5C,#44,#56,#58,#40,#55,#4C,#52,#4E,#57,#47,#4A,#5B,#4B

defb #54,#54

include 'dzx0_standard.asm'
include 'trackload.asm'
SMALLKEYBOARD equ 1
include 'keyboard.asm' ; light

unzx0 dzx0_standard (void)

include './zik/leon_playerconfig.asm'
include './zik/playerAKG.asm'
muzik include './zik/leon.asm'

Trackload_Data
defb 31 : defw #D0D4,#4000        ; sprites
defb 32 : defw #D0D4,#4000-5*1024 ; decor
defb 255
Trackload_EcranTitre
defb 33 : defw #D0D4,#4000        ; screen
defb 34 : defw #D0D1,#4000+5*1024
defb 255
TrackLoad_Menu
defb 35 : defw #D0D4,0
defb 36 : defw #D0D4,5*1024
defb 37 : defw #D0D4,10*1024
defb 38 : defw #D1D1,15*1024
defb 255
;introspr
;incbin './assets/IntroSpriteSheet1.bin'
;defs 60*21
;swim
;incbin './assets/IntroSpriteSheet2.bin'

rst000
ld a,h : add 8 : ld h,a : and #38 : ret nz
ld a,h : sub #40 : ld h,a : ld a,l : add 80 : ld l,a : ret nc
inc h
ret
rst000end

print 'ending in ',{hex}$,' size=',{hex}($-#8000)

save 'LEON.BIN',entry,$-entry,AMSDOS
save '../ACE-DL/export/LEON.BIN',entry,$-entry,AMSDOS


edsk create,'LeonMarchandi.dsk',DATA,42,OVERWRITE
edsk drop,'LeonMarchandi.dsk','2-41'
edsk add,'LeonMarchandi.dsk','2-41:0xD0-0xD4',3 ; 5K par piste


bank : org #4000
incbin './assets/IntroDecor160.zx0' ; 5K
edsk writesect,'LeonMarchandi.dsk',#4000,$-#4000,'32:0xD0-0xD4' 

bank : org #4000
sp1z incbin './assets/IntroSpriteSheet1.zx0'
sp2z incbin './assets/IntroSpriteSheet2.zx0'
edsk writesect,'LeonMarchandi.dsk',#4000,$-#4000,'31:0xD0-0xD4'  ; 5K

bank : org #4000
EcranTitre incbin './assets/EcranTitre.zx0' ; 7K
edsk writesect,'LeonMarchandi.dsk',#4000,$-#4000,'33:0xD0-0xD4 34:0xD0-0xD1'

